// ResNet LauncherDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ResNet Launcher.h"
#include "ResNet LauncherDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CResNetLauncherDlg dialog

CResNetLauncherDlg::CResNetLauncherDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CResNetLauncherDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CResNetLauncherDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

BEGIN_MESSAGE_MAP(CResNetLauncherDlg, CDialog)
	//{{AFX_MSG_MAP(CResNetLauncherDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CTLCOLOR()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_SETCURSOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

////////////////////////////////////////////////////////////////////////////
// CResNetLauncherDlg message handlers

BOOL CResNetLauncherDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_Over1 = m_Over2 = m_Over3 = m_Over4 = false;
	m_Act1 = m_Act2 = m_Act3 = m_Act4 = true;

	m_hLinkCursor = AfxGetApp()->LoadCursor(IDC_CURSOR_HAND);

	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));

	memset(&lf_on, 0, sizeof(LOGFONT));
	lf_on.lfUnderline = true;
	strcpy(lf_on.lfFaceName,"System");
	lf_on.lfWeight = 700;

	memcpy(&lf_off, &lf_on, sizeof(LOGFONT));
	lf_off.lfUnderline = false;

	m_lFontOn.CreateFontIndirect(&lf_on);
	m_lFontOff.CreateFontIndirect(&lf_off);

	m_wndbkBrush.CreateSolidBrush(RGB(255,255,255)); 

	m_Link1 = static_cast<CStatic*>(GetDlgItem(IDC_LINK1));
	m_Link2 = static_cast<CStatic*>(GetDlgItem(IDC_LINK2));
	m_Link3 = static_cast<CStatic*>(GetDlgItem(IDC_LINK3));
	m_Link4 = static_cast<CStatic*>(GetDlgItem(IDC_LINK4));

	m_Link1->GetClientRect(m_Rect1);
	m_Link1->ClientToScreen(&m_Rect1);
	this->ScreenToClient(&m_Rect1);

	m_Link2->GetClientRect(m_Rect2);
	m_Link2->ClientToScreen(&m_Rect2);
	this->ScreenToClient(&m_Rect2);

	m_Link3->GetClientRect(m_Rect3);
	m_Link3->ClientToScreen(&m_Rect3);
	this->ScreenToClient(&m_Rect3);

	m_Link4->GetClientRect(m_Rect4);
	m_Link4->ClientToScreen(&m_Rect4);
	this->ScreenToClient(&m_Rect4);

	m_Link1->SetFont(&m_lFontOff);
	m_Link1->SetWindowText("  Configure computer for BSC ResNet  ");

	m_Link2->SetFont(&m_lFontOff);
	m_Link2->SetWindowText("  Install Netscape Communicator 4.74  ");

	m_Link3->SetFont(&m_lFontOff);
	m_Link3->SetWindowText("  Install Internet Explorer 5.5  ");

	m_Link4->SetFont(&m_lFontOff);
	m_Link4->SetWindowText("  On-CD Copy of the ResNet Web Page  ");

	this->SetFocus();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CResNetLauncherDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CResNetLauncherDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CResNetLauncherDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CResNetLauncherDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

BOOL CResNetLauncherDlg::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE)
	{
		return TRUE;
	}

	return CDialog::PreTranslateMessage(pMsg);
}

HBRUSH CResNetLauncherDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	static int j = 0;

	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	if (nCtlColor == CTLCOLOR_STATIC)
	{
		SetBkColor(pDC->GetSafeHdc(), RGB(255,255,255));
		SetTextColor(pDC->GetSafeHdc(), OFFTEXT);
	}

	if ( pWnd->GetDlgCtrlID() == IDC_LINK1 )
		if (m_Over1 == true)
			SetTextColor(pDC->GetSafeHdc(), ONTEXT);

	if ( pWnd->GetDlgCtrlID() == IDC_LINK2 )
		if (m_Over2 == true)
			SetTextColor(pDC->GetSafeHdc(), ONTEXT);

	if ( pWnd->GetDlgCtrlID() == IDC_LINK3 )
		if (m_Over3 == true)
			SetTextColor(pDC->GetSafeHdc(), ONTEXT);

	if ( pWnd->GetDlgCtrlID() == IDC_LINK4 )
		if (m_Over4 == true)
			SetTextColor(pDC->GetSafeHdc(), ONTEXT);

		// TODO: Change any attributes of the DC here
	if (nCtlColor == CTLCOLOR_DLG || nCtlColor == CTLCOLOR_STATIC)		
		return (HBRUSH) m_wndbkBrush.GetSafeHandle(); 

	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

BOOL CResNetLauncherDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	if(m_wndbkBrush.GetSafeHandle())
		m_wndbkBrush.DeleteObject();
	
	return CDialog::DestroyWindow();
}

void CResNetLauncherDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	
	// LINK 1
	if (m_Rect1.PtInRect(point))
	{
		m_Over1 = true;
		SetCursor(m_hLinkCursor);
		m_Link1->SetFont(&m_lFontOn);
		m_Link1->Invalidate();
	}
	else if (m_Over1 == true)
	{
		m_Over1 = false;
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
		m_Link1->SetFont(&m_lFontOff);
		m_Link1->Invalidate();
	}

	// LINK 2
	if (m_Rect2.PtInRect(point))
	{
		m_Over2 = true;
		SetCursor(m_hLinkCursor);
		m_Link2->SetFont(&m_lFontOn);
		m_Link2->Invalidate();
	}
	else if (m_Over2 == true)
	{
		m_Over2 = false;
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
		m_Link2->SetFont(&m_lFontOff);
		m_Link2->Invalidate();
	}

	// LINK 3
	if (m_Rect3.PtInRect(point))
	{
		m_Over3 = true;
		SetCursor(m_hLinkCursor);
		m_Link3->SetFont(&m_lFontOn);
		m_Link3->Invalidate();
	}
	else if (m_Over3 == true)
	{
		m_Over3 = false;
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
		m_Link3->SetFont(&m_lFontOff);
		m_Link3->Invalidate();
	}

	// LINK 4
	if (m_Rect4.PtInRect(point))
	{
		m_Over4 = true;
		SetCursor(m_hLinkCursor);
		m_Link4->SetFont(&m_lFontOn);
		m_Link4->Invalidate();
	}
	else if (m_Over4 == true)
	{
		m_Over4 = false;
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
		m_Link4->SetFont(&m_lFontOff);
		m_Link4->Invalidate();
	}

	CDialog::OnMouseMove(nFlags, point);
}

void CResNetLauncherDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (m_Rect1.PtInRect(point) && m_Act1)
	{
		SetTimer(TIMER_ACT1, LINK_DELAY, NULL);
		m_Act1 = false;
		_spawnl(_P_NOWAITO, "ResNetConfig.exe", "ResNetConfig.exe", NULL);
	}
	else if (m_Rect2.PtInRect(point) && m_Act2)
	{
		SetTimer(TIMER_ACT2, LINK_DELAY, NULL);
		m_Act2 = false;
		_spawnl(_P_NOWAITO, "cc32d474.exe", "cc32d474.exe", NULL);
	}
	else if (m_Rect3.PtInRect(point) && m_Act3)
	{
		SetTimer(TIMER_ACT3, LINK_DELAY, NULL);
		m_Act3 = false;
		_spawnl(_P_NOWAITO, "ie5\\ie5setup.exe", "ie5\\ie5setup.exe", NULL);
	}
	else if (m_Rect4.PtInRect(point) && m_Act4)
	{
		SetTimer(TIMER_ACT1, LINK_DELAY, NULL);
		m_Act4 = false;
		ShellExecute(NULL, "open", "NetHelp\\index.html", NULL, NULL, SW_SHOWNORMAL);
	}

	
	CDialog::OnLButtonUp(nFlags, point);
}

BOOL CResNetLauncherDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: Add your message handler code here and/or call default

//	AfxMessageBox("HI");

	return false;
	
	// return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

LRESULT CResNetLauncherDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if (message == WM_TIMER)
	{
		switch (wParam)
		{
		case TIMER_ACT1:
			KillTimer(TIMER_ACT1);
			m_Act1 = true;
			break;
		case TIMER_ACT2:
			KillTimer(TIMER_ACT2);
			m_Act2 = true;
			break;
		case TIMER_ACT3:
			KillTimer(TIMER_ACT3);
			m_Act3 = true;
			break;
		case TIMER_ACT4:
			KillTimer(TIMER_ACT4);
			m_Act4 = true;
			break;
		}
	}
	return CDialog::DefWindowProc(message, wParam, lParam);
}
